#!/usr/bin/perl
my ($timeout) = @ARGV;
#alarm ($timeout - 5);
my $best, $bestlength, $pid;
$best = "";
$bestlength = -1 >> 1;

while(<STDIN>) {
  last if /^\<\>$/;
  last mainloop if /^\<END\>$/;
  $best .= $_;
}

$bestlength = length $best;
open(SAVE, ">/tmp/cedilla$$");
print SAVE $best;
close SAVE;

sub alarm_handler {
  local($sig) = @_;
#  print "$sig\n";
  chomp $best;
  print $best;
  kill 15, $pid;
  exit(0);
}

#$SIG{INT} = \&alarm_handler;
#$SIG{ALRM} = \&alarm_handler;
#$SIG{CHLD} = \&alarm_handler;

select STDIN; $| = 1;
select STDOUT; $| = 1;
$pid = open HTML, "./icfp -nophase </tmp/cedilla$$|";
select HTML; $| = 1;

select STDOUT;
mainloop:
while(1) {
  my  $candidate, $candlen, $rout;
  $candidate = "";
  while(<HTML>) {
    last if /^\<\>$/;
    last mainloop if /^\<END\>$/;
    $candidate .= $_;
  }
  $candlen = length $candidate;
  if($candlen < $bestlength) {
    $best = $candidate;
    $bestlength = $candlen;
  }
}
alarm_handler("ALRM");
