public final class Context implements Cloneable {
    private boolean b;
    private boolean em;
    private boolean i;
    private boolean s;
    private boolean tt;
    private int u;
    private int size; /* initial is -1 */
    private char color; /* initial is 'q' */

    /**
     * creates a root context
     */
    public Context()
    {
	/* everything else defaults to false/0 */
	size=-1;
	color='q';
    }

    public int getu()
    {
	return u;
    }

    public Object clone()
    {
	try {
	    return super.clone();
	} catch (CloneNotSupportedException e) { return null; }
    }

    public boolean equals(Context c)
    {
	return b==c.b && em==c.em && i==c.i && s==c.s && tt==c.tt
	    && u==c.u && size==c.size && color==c.color;
    }

    public boolean equals(Object o)
    {
	if(! (o instanceof Context)) {
	    return false;
	}
	return equals((Context) o);
    }
}
